<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      :add-button-text="dictionaryRu.addButtonTitle"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      :title="newStatus ? dictionaryRu.modal.add_title : dictionaryRu.modal.view_title"
      custom-class="modal-medium"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
    >
      <forwarding-unit
        :data-source="selectedData"
        :api="api"
        @delete="onDelete"
        @submit="preparedSave"
        @refresh="onRefresh"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import paging         from '@/mixins/dictionaries/paging';
import itemMixin      from '@/mixins/dictionaries/edit-item';
import SinglePane     from 'common-components/src/obComponents/obSinglePanels';
import ForwardingUnit from './modal/ForwardingUnit';
import ObModal        from 'common-components/src/obComponents/obModal';
import ObTable        from 'common-components/src/obComponents/obTable';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__resources__forwarding_unit';

export default {
  name: 'ForwardingUnits',
  components: {
    ObModal,
    ForwardingUnit,
    ObTable,
    SinglePane
  },
  mixins: [
    paging,
    itemMixin
  ],
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.denomination,
          key: 'denomination'
        },
        {
          title: this.dictionaryRu.columns.shorthand,
          key: 'shorthand'
        },
        {
          title: this.dictionaryRu.columns.international_shorthand,
          key: 'international_shorthand'
        },
        {
          title: this.dictionaryRu.columns.description,
          key: 'description'
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          allowSorting: false,
          html: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        }
      ];
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      dataGridRefName: 'ForwardingUnit',
      api: {
        source: '/oboz2-dictionary-forwarding-units-crud/v1/'
      }
    };
  },
  methods: {
    preparedSave(payload) {
      this.onSave(payload);
    }
  }
};
</script>
